#!/bin/bash
# use --nose to disable selinux (saves CPU cycles in VMs)

cat 1_hosts.add >>/etc/hosts

if [ "$1" = "--nose" ]; then
  #yum -y install policycoreutils setroubleshoot*
  chmod 000 `which setroubleshootd 2>/dev/null` &>/dev/null
  chmod 000 `which sealert 2>/dev/null` &>/dev/null
  sed -i -e "s/^SELINUX=.*/SELINUX=disabled/" /etc/selinux/config
  setenforce 0
fi

yum -y groupinstall virtualization
yum -y install vzctl-core
[ -e centos-7-x86_64.tar.gz ] && mv centos-7-x86_64.tar.gz /var/lib/vz/template/cache/ || wget -c http://download.openvz.org/template/precreated/centos-7-x86_64.tar.gz -O /var/lib/vz/template/cache/centos-7-x86_64.tar.gz

for n in 0 1 2 3; do
  if grep 192\.168\.12$((4+$n))\. /etc/libvirt/qemu/networks/* &> /dev/null; then
    echo "ATTENTION. There is already a network 192.168.12$((4+$n)).0 defined."
    echo "This will probably break the installation and should be fixed in"
    echo "/etc/libvirt/qemu/networks/* before running the next script. You"
    echo "have to restart libvirtd to enable your changes for the bridges."
    continue
  fi
  cat <<EOF >/etc/libvirt/qemu/networks/openvz$n.xml
<network>
  <name>openvz$n</name>
  <forward mode='nat'/>
  <bridge name='vzbr$n' stp='on' delay='0'/>
  <mac address='52:54:00:64:64:b$n'/>
  <domain name='openvz.local'/>
  <ip address='192.168.12$((4+$n)).1' netmask='255.255.255.0'>
    <dhcp>
      <range start='192.168.12$((4+$n)).100' end='192.168.12$((4+$n)).200'/>
    </dhcp>
  </ip>
</network>
EOF
  ln -sf /etc/libvirt/qemu/networks/openvz$n.xml /etc/libvirt/qemu/networks/autostart
done

systemctl restart libvirtd

sleep 10s
ip a|grep vzbr|grep inet
