#!/bin/bash

# preload some modules
for n in openvswitch br_netfilter vport-gre bridge nf_conntrack_proto_sctp iscsi_target_mod iscsi_tcp target_core_mod configfs btrfs xfs nfsd ib_srpt target_core_file target_core_iblock target_core_pscsi tcm_fc tcm_loop vhost_scsi tcm_qla2xxx; do
  modprobe $n
done

sysctl net.ipv4.tcp_keepalive_intvl=1
sysctl net.ipv4.tcp_keepalive_probes=5
sysctl net.ipv4.tcp_keepalive_time=5

echo "Attention... this will destroy all OpenStack Liberty VEs."
read -p "CTRL+C to abort, return to continue..."
for o in {0..4}; do
  export VENAME=oslnode$o
  export ADD=""
  [ "$o" = "0" ] && export VENAME=oslcontroller && export ADD="--local_uid 0"
  [ "$o" = "4" ] && export VENAME=oslnet
  export VEID="140$o"
  echo "##################################################"
  echo "### creating $VENAME ($VEID)"
  source /etc/vz/vz.conf
  vzctl stop $VEID
  for m in {0..3}; do
    DEVICE="veth$VEID.$m"
    if ifconfig $DEVICE &>/dev/null; then
      echo "Definitely removing $DEVICE."
      ifconfig $DEVICE down
      ip link delete $DEVICE
    fi
  done
  vzctl destroy $VEID
  vzctl create $VEID --name $VENAME --hostname $VENAME --ostemplate centos-7-x86_64 $ADD
  for n in {0..3}; do
    vzctl set $VEID --netif_add eth$n,,,,vzbr$n --save
    cat <<EOF >$VE_PRIVATE/etc/sysconfig/network-scripts/ifcfg-eth$n
DEVICE=eth$n
NAME="eth$n"
TYPE="Ethernet"
BOOTPROTO=none
ONBOOT=yes
USERCTL=no
EOF
    [ "$n" = "1" ] || cat <<EOF >>$VE_PRIVATE/etc/sysconfig/network-scripts/ifcfg-eth$n
NETMASK=255.255.255.0
IPADDR=192.168.12$((4+$n)).11$o
EOF
  done; 
  cat <<EOF >$VE_PRIVATE/etc/sysconfig/network
NETWORKING=yes
HOSTNAME=$VENAME
GATEWAY=192.168.124.1
EOF
  cat 1_hosts.add >>$VE_PRIVATE/etc/hosts
  mkdir -p ${VE_PRIVATE}/root/.ssh
  chmod 700 ${VE_PRIVATE}/root/.ssh
  cp -a /root/.ssh/authorized_keys ${VE_PRIVATE}/root/.ssh/authorized_keys
  chown root.root ${VE_PRIVATE}/root/.ssh/authorized_keys
  cp -a $VE_PRIVATE/etc/`LANG=C stat -c %N /etc/localtime|cut -d\' -f4` $VE_PRIVATE/etc/localtime 2>/dev/null || cp -a /etc/localtime $VE_PRIVATE/etc/localtime
  rm -rf ${VE_PRIVATE}/etc/systemd/system/getty.target.wants
  cp -a ${VE_PRIVATE}/usr/lib/systemd/system/getty@.service ${VE_PRIVATE}/etc/systemd/system/
  sed -i -e "s/ConditionPathExists=.*/ConditionPathExists=\/dev\/dummy/" ${VE_PRIVATE}/etc/systemd/system/getty@.service
  [ -e ${VE_PRIVATE}/etc/selinux/targeted/contexts/dbus_contexts ] || { mkdir -p ${VE_PRIVATE}/etc/selinux/targeted/contexts/; cp -a /etc/selinux/targeted/contexts/dbus_contexts ${VE_PRIVATE}/etc/selinux/targeted/contexts; }
  [ -e ${VE_PRIVATE}/etc/fstab.org ] || mv ${VE_PRIVATE}/etc/fstab ${VE_PRIVATE}/etc/fstab.org
  echo "none /dev/pts devpts rw,nosuid,noexec,relatime,seclabel,gid=5,mode=620,ptmxmode=000 0 0" >  ${VE_PRIVATE}/etc/fstab
  echo "proc /proc proc defaults 0 0" >> ${VE_PRIVATE}/etc/fstab
  mknod -m 666 ${VE_PRIVATE}/dev/kvm c 10 232 
  vzctl start $VENAME
  sleep 10s
  echo "##################################################"
  echo "### checking interfaces"
  ssh -oStrictHostKeyChecking=no -oUserKnownHostsFile=/dev/null root@$VENAME ip a\|grep "inet\ "
  echo
done

echo "##################################################"
echo "### if you are repeating this step do not forget"
echo "### to remove the host keys from .ssh/known_hosts"
