#!/bin/bash
for o in {0..4}; do
  export VENAME=oslnode$o
  [ "$o" = "0" ] && export VENAME=oslcontroller
  [ "$o" = "4" ] && export VENAME=oslnet
  export VEID="140$o"
  echo "##################################################"
  echo "### setting up $VENAME ($VEID)"
  source /etc/vz/vz.conf
  ssh -oStrictHostKeyChecking=no root@$VENAME <<EOF
    for p in redis mongod rabbitmq-server neutron-openvswitch-agent neutron-server httpd; do
      cp /etc/systemd/system/multi-user.target.wants/\$p.service /etc/systemd/system 2>/dev/null || continue
      sed -i -e "s/ExecStart/Restart=always\nRestartSec=5\nExecStart/" /etc/systemd/system/\$p.service && echo "\$p patched..."
      systemctl daemon-reload
    done
EOF
done

ssh -oStrictHostKeyChecking=no root@oslnet <<EOF
    ovs-vsctl add-port br-ex eth1
    
    rpm -qa|grep rdo-release | grep liberty || exit 0

    # in Liberty the config has changed it's place... but only partly
    ln -s openvswitch_agent.ini /etc/neutron/plugins/ml2/ml2_conf.ini && systemctl restart neutron-l3-agent.service && sleep 10s
EOF

ssh -oStrictHostKeyChecking=no root@oslcontroller <<EOF
    # if we had a demo setup, give it a working DNS
    . /root/keystonerc_demo
    neutron subnet-update --dns-nameserver 8.8.8.8 private_subnet

    rpm -qa|grep rdo-release | grep liberty || exit 0

    # Recreate router for private network in Liberty
    neutron router-interface-delete router1 private_subnet
    neutron router-delete router1
    neutron router-create router1
    neutron router-gateway-set router1 public
    neutron router-interface-add router1 private_subnet    
EOF

# Use the following for the error "Unable to retrieve volume limit information." in Liberty.
ssh -oStrictHostKeyChecking=no root@oslcontroller <<EOF
rpm -qa|grep rdo-release | grep liberty || exit 0
grep "ERROR cinder.api.middleware.fault .* Caught error: Not enough information to determine URL. Provide either auth_url or endpoint" /var/log/cinder/api.log >/dev/null
if [ "$?" = "0" ] && ! grep "auth_plugin = password" /etc/cinder/cinder.conf >/dev/null; then
  PASSWORD="\`grep CINDER_KS_PW packstack-answers-multinode.txt|cut -d= -f2\`"
  cat <<END >>/etc/cinder/cinder.conf

[keystone_authtoken]
auth_uri = http://192.168.124.110:5000
auth_url = http://192.168.124.110:35357
auth_plugin = password
project_domain_id = default
user_domain_id = default
project_name = services
username = cinder
password = \$PASSWORD

END
  openstack-service restart cinder
fi
EOF

